Package org.opencv.bioinspired

## Class TransientAreasSegmentationModule

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.bioinspired.TransientAreasSegmentationModule

-     public class TransientAreasSegmentationModule
      extends Algorithm

  class which provides a transient/moving areas segmentation module perform a locally adapted segmentation by using the retina magno input data Based on Alexandre BENOIT thesis: "Le système visuel humain au secours de la vision par ordinateur" 3 spatio temporal filters are used:
  - a first one which filters the noise and local variations of the input motion energy
  - a second (more powerfull low pass spatial filter) which gives the neighborhood motion energy the segmentation consists in the comparison of these both outputs, if the local motion energy is higher to the neighborhood otion energy, then the area is considered as moving and is segmented
  - a stronger third low pass filter helps decision by providing a smooth information about the "motion context" in a wider area

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `TransientAreasSegmentationModule​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static TransientAreasSegmentationModule` | `__fromPtr__​(long addr)` |
    `void` | `clearAllBuffers()` | cleans all the buffers of the instance
    `static TransientAreasSegmentationModule` | `create​(Size inputSize)` | allocator
    `protected void` | `finalize()` |
    `void` | `getSegmentationPicture​(Mat transientAreas)` | access function return the last segmentation result: a boolean picture which is resampled between 0 and 255 for a display purpose
    `Size` | `getSize()` | return the sze of the manage input and output images
    `java.lang.String` | `printSetup()` | parameters setup display method
    `void` | `run​(Mat inputToSegment)` | main processing method, get result using methods getSegmentationPicture()
    `void` | `run​(Mat inputToSegment, int channelIndex)` | main processing method, get result using methods getSegmentationPicture()
    `void` | `setup()` | try to open an XML segmentation parameters file to adjust current segmentation instance setup if the xml file does not exist, then default setup is applied warning, Exceptions are thrown if read XML file is not valid
    `void` | `setup​(java.lang.String segmentationParameterFile)` | try to open an XML segmentation parameters file to adjust current segmentation instance setup if the xml file does not exist, then default setup is applied warning, Exceptions are thrown if read XML file is not valid
    `void` | `setup​(java.lang.String segmentationParameterFile, boolean applyDefaultSetupOnFailure)` | try to open an XML segmentation parameters file to adjust current segmentation instance setup if the xml file does not exist, then default setup is applied warning, Exceptions are thrown if read XML file is not valid
    `void` | `write​(java.lang.String fs)` | write xml/yml formated parameters information

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, empty, getDefaultName, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TransientAreasSegmentationModule

          protected TransientAreasSegmentationModule​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static TransientAreasSegmentationModule __fromPtr__​(long addr)

    - #### getSize

          public Size getSize()

      return the sze of the manage input and output images
      Returns:
        automatically generated

    - #### setup

          public void setup​(java.lang.String segmentationParameterFile,
                            boolean applyDefaultSetupOnFailure)

      try to open an XML segmentation parameters file to adjust current segmentation instance setup
      - if the xml file does not exist, then default setup is applied
      - warning, Exceptions are thrown if read XML file is not valid
      Parameters:
        `segmentationParameterFile` - : the parameters filename
        `applyDefaultSetupOnFailure` - : set to true if an error must be thrown on error

    - #### setup

          public void setup​(java.lang.String segmentationParameterFile)

      try to open an XML segmentation parameters file to adjust current segmentation instance setup
      - if the xml file does not exist, then default setup is applied
      - warning, Exceptions are thrown if read XML file is not valid
      Parameters:
        `segmentationParameterFile` - : the parameters filename

    - #### setup

          public void setup()

      try to open an XML segmentation parameters file to adjust current segmentation instance setup
      - if the xml file does not exist, then default setup is applied
      - warning, Exceptions are thrown if read XML file is not valid

    - #### printSetup

          public java.lang.String printSetup()

      parameters setup display method
      Returns:
        a string which contains formatted parameters information

    - #### write

          public void write​(java.lang.String fs)

      write xml/yml formated parameters information
      Parameters:
        `fs` - : the filename of the xml file that will be open and writen with formatted parameters information

    - #### run

          public void run​(Mat inputToSegment,
                          int channelIndex)

      main processing method, get result using methods getSegmentationPicture()
      Parameters:
        `inputToSegment` - : the image to process, it must match the instance buffer size !
        `channelIndex` - : the channel to process in case of multichannel images

    - #### run

          public void run​(Mat inputToSegment)

      main processing method, get result using methods getSegmentationPicture()
      Parameters:
        `inputToSegment` - : the image to process, it must match the instance buffer size !

    - #### getSegmentationPicture

          public void getSegmentationPicture​(Mat transientAreas)

      access function return the last segmentation result: a boolean picture which is resampled between 0 and 255 for a display purpose
      Parameters:
        `transientAreas` - automatically generated

    - #### clearAllBuffers

          public void clearAllBuffers()

      cleans all the buffers of the instance

    - #### create

          public static TransientAreasSegmentationModule create​(Size inputSize)

      allocator
      Parameters:
        `inputSize` - : size of the images input to segment (output will be the same size)
      Returns:
        automatically generated

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Algorithm`
      Throws:
        `java.lang.Throwable`